## punes-0.111.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(puNES)
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED TRUE)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

string(TIMESTAMP COMPILED_TIMESTAMP "%m%d%Y%H%M%S")

#variable_watch(ENABLE_WIN_STATIC_QT560)

# Options
option(ENABLE_GIT_INFO "Include Git info" OFF)
option(ENABLE_RELEASE "Build release version" ON)
option(ENABLE_FFMPEG "Enable FFMPEG support" ON)
option(ENABLE_OPENGL "Use OpenGL support instead of Direct3D 9 (only for Windows)" ON)
option(ENABLE_OPENGL_CG "Enable OpenGL nVidia Cg Toolkit support" OFF)
option(ENABLE_FULLSCREEN_RESFREQ "Enable Fullscreen resolution and auto frequency" ON)
option(ENABLE_QT6_LIBS "Enable support for QT6 libraries" OFF)
option(ENABLE_WIN_STATIC_QT "Use precompiled Qt static library (only for Windows)" OFF)
option(ENABLE_WIN_STATIC_QT560 "Use precompiled Qt 5.6.3 static library (only for Windows)" OFF)
option(DISABLE_PORTABLE_MODE "Disable compiling portable mode management (useful in sandbox environments like Flatpak)" OFF)

if (ENABLE_GIT_INFO)
	find_package(Git)

	if(Git_FOUND)
		execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
			OUTPUT_VARIABLE GIT_LAST_COMMIT
			ERROR_VARIABLE git_describe_error
			RESULT_VARIABLE git_describe_result
			OUTPUT_STRIP_TRAILING_WHITESPACE
			)

		execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse HEAD
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
			OUTPUT_VARIABLE GIT_LAST_COMMIT_HASH
			ERROR_VARIABLE git_describe_error
			RESULT_VARIABLE git_describe_result
			OUTPUT_STRIP_TRAILING_WHITESPACE
			)

		execute_process(COMMAND ${GIT_EXECUTABLE} rev-list --count HEAD
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
			OUTPUT_VARIABLE GIT_COUNT_COMMITS
			ERROR_VARIABLE git_describe_error
			RESULT_VARIABLE git_describe_result
			OUTPUT_STRIP_TRAILING_WHITESPACE
			)
	endif()
endif()

# For installation targets
include(GNUInstallDirs)

# sizeof checking for xdelta config.h generation
include(CheckTypeSize)
check_type_size("size_t" SIZEOF_SIZE_T)
check_type_size("unsigned int" SIZEOF_UNSIGNED_INT)
check_type_size("unsigned long" SIZEOF_UNSIGNED_LONG)
check_type_size("unsigned long long" SIZEOF_UNSIGNED_LONG_LONG)
configure_file(xdelta_config.h.in config.h)

configure_file(compiled.h.in compiled.h)

include(TargetArch)
target_architecture(HOST_CPU)

# handling external dependencies
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_AUTOUIC_SEARCH_PATHS gui/designer)

set(QT_LIBS_USED "")
set(WIN_LIBS_USED "")

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	find_package(ALSA REQUIRED)
	find_package(PkgConfig REQUIRED)
	pkg_check_modules(UDEV REQUIRED IMPORTED_TARGET libudev)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
	find_package(Sndio REQUIRED)
	find_package(UsbHid REQUIRED)
	set(ENABLE_OPENGL_CG OFF)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD" OR CMAKE_SYSTEM_NAME STREQUAL "Linux")
	if(ENABLE_FULLSCREEN_RESFREQ)
		find_package(X11 REQUIRED)
	endif()
	# No alternatives, force selection
	set(ENABLE_OPENGL ON)
	if(ENABLE_OPENGL_CG)
		find_package(Cg REQUIRED)
	endif()
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
	if(ENABLE_WIN_STATIC_QT560)
		set(ENABLE_WIN_STATIC_QT ON)
	endif()
	# No alternatives, force selection
	set(ENABLE_OPENGL_CG ${ENABLE_OPENGL})
	set(ENABLE_FULLSCREEN_RESFREQ ON)
else()
	set(ENABLE_WIN_STATIC_QT OFF)
	set(ENABLE_WIN_STATIC_QT560 OFF)
endif()

# OpenGL is required for Qt, even in the case of D3D9.
if((CMAKE_SYSTEM_NAME STREQUAL "Linux") AND (NOT OpenGL_GL_PREFERENCE))
	# See CMP0072 for more details (cmake --help-policy CMP0072)
	set(OpenGL_GL_PREFERENCE "GLVND")
endif()
find_package(OpenGL REQUIRED)

if(ENABLE_QT6_LIBS)
	find_package(Qt6 6.0.0 COMPONENTS Core LinguistTools Widgets Network Svg Gui OpenGLWidgets REQUIRED)
	set(QT_VERSION ${Qt6_VERSION})
else()
	find_package(Qt5 5.6.3 COMPONENTS Core LinguistTools Widgets Network Svg Gui REQUIRED)
	set(QT_VERSION ${Qt5_VERSION})
endif()

message(STATUS "Found Qt: ${QT_VERSION}")

if(${QT_VERSION} VERSION_LESS "5.15.0")
	macro(qt_add_translation)
		qt5_add_translation(${ARGN})
	endmacro()
	macro(qt_add_resources)
		qt5_add_resources(${ARGN})
	endmacro()
endif()

if(ENABLE_WIN_STATIC_QT)
	include(WinStaticQt)
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

if(ENABLE_FFMPEG)
	find_package(PkgConfig REQUIRED)
	pkg_check_modules(LIBAV REQUIRED IMPORTED_TARGET
		libavformat
		libavcodec
		libswresample
		libswscale
		libavutil
		)
endif()

if(${QT_VERSION} VERSION_LESS "5.15.0")
	set(QT_LIBS_USED ${QT_LIBS_USED} Qt5::Core)
	set(QT_LIBS_USED ${QT_LIBS_USED} Qt5::Network)
	set(QT_LIBS_USED ${QT_LIBS_USED} Qt5::Widgets)
	set(QT_LIBS_USED ${QT_LIBS_USED} Qt5::Svg)
	set(QT_LIBS_USED ${QT_LIBS_USED} Qt5::Gui)
else()
	set(QT_LIBS_USED ${QT_LIBS_USED} Qt::Core)
	set(QT_LIBS_USED ${QT_LIBS_USED} Qt::Network)
	set(QT_LIBS_USED ${QT_LIBS_USED} Qt::Widgets)
	set(QT_LIBS_USED ${QT_LIBS_USED} Qt::Svg)
	set(QT_LIBS_USED ${QT_LIBS_USED} Qt::Gui)
	if(${QT_VERSION} VERSION_GREATER_EQUAL "6.0.0")
		set(QT_LIBS_USED ${QT_LIBS_USED} Qt::OpenGLWidgets)
	endif()
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
	set(WIN_LIBS_USED ${WIN_LIBS_USED} ws2_32)
	set(WIN_LIBS_USED ${WIN_LIBS_USED} imm32)
	set(WIN_LIBS_USED ${WIN_LIBS_USED} cg)
	if(ENABLE_OPENGL)
		if(ENABLE_OPENGL_CG)
			set(WIN_LIBS_USED ${WIN_LIBS_USED} cgGL)
		endif()
	else()
		set(WIN_LIBS_USED ${WIN_LIBS_USED} cgD3D9)
		set(WIN_LIBS_USED ${WIN_LIBS_USED} d3d9)
	endif()
endif()

add_subdirectory(src)

# Install misc files
install(FILES misc/io.github.punesemu.puNES.desktop.in
	DESTINATION ${CMAKE_INSTALL_DATADIR}/applications RENAME io.github.punesemu.puNES.desktop)

foreach(SIZE "16" "22" "24" "32" "48" "64" "256" "512")
	install(FILES misc/hicolor_apps_${SIZE}x${SIZE}_io.github.punesemu.puNES.png
		DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/${SIZE}x${SIZE}/apps RENAME io.github.punesemu.puNES.png)
endforeach()

install(FILES misc/io.github.punesemu.puNES.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
install(FILES misc/nes20db.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/puNES)
install(FILES misc/dip.cfg DESTINATION ${CMAKE_INSTALL_DATADIR}/puNES)

install(FILES README.md ChangeLog DESTINATION ${CMAKE_INSTALL_DOCDIR})

=== libavfilter/Makefile ===
NAME = avfilter
DESC = FFmpeg audio/video filtering library

HEADERS = avfilter.h                                                    \
          buffersink.h                                                  \
          buffersrc.h                                                   \
          version.h                                                     \

OBJS = allfilters.o                                                     \
       audio.o                                                          \
       avfilter.o                                                       \
       avfiltergraph.o                                                  \
       buffersink.o                                                     \
       buffersrc.o                                                      \
       drawutils.o                                                      \
       fifo.o                                                           \
       formats.o                                                        \
       framepool.o                                                      \
       framequeue.o                                                     \
       graphdump.o                                                      \
       graphparser.o                                                    \
       transform.o                                                      \
       video.o                                                          \

OBJS-$(HAVE_THREADS)                         += pthread.o

# subsystems
OBJS-$(CONFIG_QSVVPP)                        += qsvvpp.o
OBJS-$(CONFIG_SCENE_SAD)                     += scene_sad.o
OBJS-$(CONFIG_DNN)                           += dnn_filter_common.o
include $(SRC_PATH)/libavfilter/dnn/Makefile

# audio filters
OBJS-$(CONFIG_ABENCH_FILTER)                 += f_bench.o
OBJS-$(CONFIG_ACOMPRESSOR_FILTER)            += af_sidechaincompress.o
OBJS-$(CONFIG_ACONTRAST_FILTER)              += af_acontrast.o
OBJS-$(CONFIG_ACOPY_FILTER)                  += af_acopy.o
OBJS-$(CONFIG_ACROSSFADE_FILTER)             += af_afade.o
OBJS-$(CONFIG_ACROSSOVER_FILTER)             += af_acrossover.o
OBJS-$(CONFIG_ACRUSHER_FILTER)               += af_acrusher.o
OBJS-$(CONFIG_ACUE_FILTER)                   += f_cue.o
OBJS-$(CONFIG_ADECLICK_FILTER)               += af_adeclick.o
OBJS-$(CONFIG_ADECLIP_FILTER)                += af_adeclick.o
OBJS-$(CONFIG_ADELAY_FILTER)                 += af_adelay.o
OBJS-$(CONFIG_ADENORM_FILTER)                += af_adenorm.o
OBJS-$(CONFIG_ADERIVATIVE_FILTER)            += af_aderivative.o
OBJS-$(CONFIG_AECHO_FILTER)                  += af_aecho.o
OBJS-$(CONFIG_AEMPHASIS_FILTER)              += af_aemphasis.o
OBJS-$(CONFIG_AEVAL_FILTER)                  += aeval.o
OBJS-$(CONFIG_AEXCITER_FILTER)               += af_aexciter.o
OBJS-$(CONFIG_AFADE_FILTER)                  += af_afade.o
OBJS-$(CONFIG_AFFTDN_FILTER)                 += af_afftdn.o
OBJS-$(CONFIG_AFFTFILT_FILTER)               += af_afftfilt.o
OBJS-$(CONFIG_AFIR_FILTER)                   += af_afir.o
OBJS-$(CONFIG_AFORMAT_FILTER)                += af_aformat.o
OBJS-$(CONFIG_AFREQSHIFT_FILTER)             += af_afreqshift.o
OBJS-$(CONFIG_AGATE_FILTER)                  += af_agate.o
OBJS-$(CONFIG_AIIR_FILTER)                   += af_aiir.o
OBJS-$(CONFIG_AINTEGRAL_FILTER)              += af_aderivative.o
OBJS-$(CONFIG_AINTERLEAVE_FILTER)            += f_interleave.o
OBJS-$(CONFIG_ALIMITER_FILTER)               += af_alimiter.o
OBJS-$(CONFIG_ALLPASS_FILTER)                += af_biquads.o
OBJS-$(CONFIG_ALOOP_FILTER)                  += f_loop.o
OBJS-$(CONFIG_AMERGE_FILTER)                 += af_amerge.o
OBJS-$(CONFIG_AMETADATA_FILTER)              += f_metadata.o
OBJS-$(CONFIG_AMIX_FILTER)                   += af_amix.o
OBJS-$(CONFIG_AMULTIPLY_FILTER)              += af_amultiply.o
OBJS-$(CONFIG_ANEQUALIZER_FILTER)            += af_anequalizer.o
OBJS-$(CONFIG_ANLMDN_FILTER)                 += af_anlmdn.o
OBJS-$(CONFIG_ANLMS_FILTER)                  += af_anlms.o
OBJS-$(CONFIG_ANULL_FILTER)                  += af_anull.o
OBJS-$(CONFIG_APAD_FILTER)                   += af_apad.o
OBJS-$(CONFIG_APERMS_FILTER)                 += f_perms.o
OBJS-$(CONFIG_APHASER_FILTER)                += af_aphaser.o generate_wave_table.o
OBJS-$(CONFIG_APHASESHIFT_FILTER)            += af_afreqshift.o
OBJS-$(CONFIG_APULSATOR_FILTER)              += af_apulsator.o
OBJS-$(CONFIG_AREALTIME_FILTER)              += f_realtime.o
OBJS-$(CONFIG_ARESAMPLE_FILTER)              += af_aresample.o
OBJS-$(CONFIG_AREVERSE_FILTER)               += f_reverse.o
OBJS-$(CONFIG_ARNNDN_FILTER)                 += af_arnndn.o
OBJS-$(CONFIG_ASELECT_FILTER)                += f_select.o
OBJS-$(CONFIG_ASENDCMD_FILTER)               += f_sendcmd.o
OBJS-$(CONFIG_ASETNSAMPLES_FILTER)           += af_asetnsamples.o
OBJS-$(CONFIG_ASETPTS_FILTER)                += setpts.o
OBJS-$(CONFIG_ASETRATE_FILTER)               += af_asetrate.o
OBJS-$(CONFIG_ASETTB_FILTER)                 += settb.o
OBJS-$(CONFIG_ASHOWINFO_FILTER)              += af_ashowinfo.o
OBJS-$(CONFIG_ASIDEDATA_FILTER)              += f_sidedata.o
OBJS-$(CONFIG_ASOFTCLIP_FILTER)              += af_asoftclip.o
OBJS-$(CONFIG_ASPLIT_FILTER)                 += split.o
OBJS-$(CONFIG_ASR_FILTER)                    += af_asr.o
OBJS-$(CONFIG_ASTATS_FILTER)                 += af_astats.o
OBJS-$(CONFIG_ASTREAMSELECT_FILTER)          += f_streamselect.o framesync.o
OBJS-$(CONFIG_ASUBBOOST_FILTER)              += af_asubboost.o
OBJS-$(CONFIG_ASUBCUT_FILTER)                += af_asupercut.o
OBJS-$(CONFIG_ASUPERCUT_FILTER)              += af_asupercut.o
OBJS-$(CONFIG_ASUPERPASS_FILTER)             += af_asupercut.o
OBJS-$(CONFIG_ASUPERSTOP_FILTER)             += af_asupercut.o
OBJS-$(CONFIG_ATEMPO_FILTER)                 += af_atempo.o
OBJS-$(CONFIG_ATRIM_FILTER)                  += trim.o
OBJS-$(CONFIG_AXCORRELATE_FILTER)            += af_axcorrelate.o
OBJS-$(CONFIG_AZMQ_FILTER)                   += f_zmq.o
OBJS-$(CONFIG_BANDPASS_FILTER)               += af_biquads.o
OBJS-$(CONFIG_BANDREJECT_FILTER)             += af_biquads.o
OBJS-$(CONFIG_BASS_FILTER)                   += af_biquads.o
OBJS-$(CONFIG_BIQUAD_FILTER)                 += af_biquads.o
OBJS-$(CONFIG_BS2B_FILTER)                   += af_bs2b.o
OBJS-$(CONFIG_CHANNELMAP_FILTER)             += af_channelmap.o
OBJS-$(CONFIG_CHANNELSPLIT_FILTER)           += af_channelsplit.o
OBJS-$(CONFIG_CHORUS_FILTER)                 += af_chorus.o generate_wave_table.o
OBJS-$(CONFIG_COMPAND_FILTER)                += af_compand.o
OBJS-$(CONFIG_COMPENSATIONDELAY_FILTER)      += af_compensationdelay.o
OBJS-$(CONFIG_CROSSFEED_FILTER)              += af_crossfeed.o
OBJS-$(CONFIG_CRYSTALIZER_FILTER)            += af_crystalizer.o
OBJS-$(CONFIG_DCSHIFT_FILTER)                += af_dcshift.o
OBJS-$(CONFIG_DEESSER_FILTER)                += af_deesser.o
OBJS-$(CONFIG_DRMETER_FILTER)                += af_drmeter.o
OBJS-$(CONFIG_DYNAUDNORM_FILTER)             += af_dynaudnorm.o
OBJS-$(CONFIG_EARWAX_FILTER)                 += af_earwax.o
OBJS-$(CONFIG_EBUR128_FILTER)                += f_ebur128.o
OBJS-$(CONFIG_EQUALIZER_FILTER)              += af_biquads.o
OBJS-$(CONFIG_EXTRASTEREO_FILTER)            += af_extrastereo.o
OBJS-$(CONFIG_FIREQUALIZER_FILTER)           += af_firequalizer.o
OBJS-$(CONFIG_FLANGER_FILTER)                += af_flanger.o generate_wave_table.o
OBJS-$(CONFIG_HAAS_FILTER)                   += af_haas.o
OBJS-$(CONFIG_HDCD_FILTER)                   += af_hdcd.o
OBJS-$(CONFIG_HEADPHONE_FILTER)              += af_headphone.o
OBJS-$(CONFIG_HIGHPASS_FILTER)               += af_biquads.o
OBJS-$(CONFIG_HIGHSHELF_FILTER)              += af_biquads.o
OBJS-$(CONFIG_JOIN_FILTER)                   += af_join.o
OBJS-$(CONFIG_LADSPA_FILTER)                 += af_ladspa.o
OBJS-$(CONFIG_LOUDNORM_FILTER)               += af_loudnorm.o ebur128.o
OBJS-$(CONFIG_LOWPASS_FILTER)                += af_biquads.o
OBJS-$(CONFIG_LOWSHELF_FILTER)               += af_biquads.o
OBJS-$(CONFIG_LV2_FILTER)                    += af_lv2.o
OBJS-$(CONFIG_MCOMPAND_FILTER)               += af_mcompand.o
OBJS-$(CONFIG_PAN_FILTER)                    += af_pan.o
OBJS-$(CONFIG_REPLAYGAIN_FILTER)             += af_replaygain.o
OBJS-$(CONFIG_RESAMPLE_FILTER)               += af_resample.o
OBJS-$(CONFIG_RUBBERBAND_FILTER)             += af_rubberband.o
OBJS-$(CONFIG_SIDECHAINCOMPRESS_FILTER)      += af_sidechaincompress.o
OBJS-$(CONFIG_SIDECHAINGATE_FILTER)          += af_agate.o
OBJS-$(CONFIG_SILENCEDETECT_FILTER)          += af_silencedetect.o
OBJS-$(CONFIG_SILENCEREMOVE_FILTER)          += af_silenceremove.o
OBJS-$(CONFIG_SOFALIZER_FILTER)              += af_sofalizer.o
OBJS-$(CONFIG_SPEECHNORM_FILTER)             += af_speechnorm.o
OBJS-$(CONFIG_STEREOTOOLS_FILTER)            += af_stereotools.o
OBJS-$(CONFIG_STEREOWIDEN_FILTER)            += af_stereowiden.o
OBJS-$(CONFIG_SUPEREQUALIZER_FILTER)         += af_superequalizer.o
OBJS-$(CONFIG_SURROUND_FILTER)               += af_surround.o
OBJS-$(CONFIG_TREBLE_FILTER)                 += af_biquads.o
OBJS-$(CONFIG_TREMOLO_FILTER)                += af_tremolo.o
OBJS-$(CONFIG_VIBRATO_FILTER)                += af_vibrato.o generate_wave_table.o
OBJS-$(CONFIG_VOLUME_FILTER)                 += af_volume.o
OBJS-$(CONFIG_VOLUMEDETECT_FILTER)           += af_volumedetect.o

OBJS-$(CONFIG_AEVALSRC_FILTER)               += aeval.o
OBJS-$(CONFIG_AFIRSRC_FILTER)                += asrc_afirsrc.o
OBJS-$(CONFIG_ANOISESRC_FILTER)              += asrc_anoisesrc.o
OBJS-$(CONFIG_ANULLSRC_FILTER)               += asrc_anullsrc.o
OBJS-$(CONFIG_FLITE_FILTER)                  += asrc_flite.o
OBJS-$(CONFIG_HILBERT_FILTER)                += asrc_hilbert.o
OBJS-$(CONFIG_SINC_FILTER)                   += asrc_sinc.o
OBJS-$(CONFIG_SINE_FILTER)                   += asrc_sine.o

OBJS-$(CONFIG_ANULLSINK_FILTER)              += asink_anullsink.o

# video filters
OBJS-$(CONFIG_ADDROI_FILTER)                 += vf_addroi.o
OBJS-$(CONFIG_ALPHAEXTRACT_FILTER)           += vf_extractplanes.o
OBJS-$(CONFIG_ALPHAMERGE_FILTER)             += vf_alphamerge.o framesync.o
OBJS-$(CONFIG_AMPLIFY_FILTER)                += vf_amplify.o
OBJS-$(CONFIG_ASS_FILTER)                    += vf_subtitles.o
OBJS-$(CONFIG_ATADENOISE_FILTER)             += vf_atadenoise.o
OBJS-$(CONFIG_AVGBLUR_FILTER)                += vf_avgblur.o
OBJS-$(CONFIG_AVGBLUR_OPENCL_FILTER)         += vf_avgblur_opencl.o opencl.o \
                                                opencl/avgblur.o boxblur.o
OBJS-$(CONFIG_AVGBLUR_VULKAN_FILTER)         += vf_avgblur_vulkan.o vulkan.o
OBJS-$(CONFIG_BBOX_FILTER)                   += bbox.o vf_bbox.o
OBJS-$(CONFIG_BENCH_FILTER)                  += f_bench.o
OBJS-$(CONFIG_BILATERAL_FILTER)              += vf_bilateral.o
OBJS-$(CONFIG_BITPLANENOISE_FILTER)          += vf_bitplanenoise.o
OBJS-$(CONFIG_BLACKDETECT_FILTER)            += vf_blackdetect.o
OBJS-$(CONFIG_BLACKFRAME_FILTER)             += vf_blackframe.o
OBJS-$(CONFIG_BLEND_FILTER)                  += vf_blend.o framesync.o
OBJS-$(CONFIG_BM3D_FILTER)                   += vf_bm3d.o framesync.o
OBJS-$(CONFIG_BOXBLUR_FILTER)                += vf_boxblur.o boxblur.o
OBJS-$(CONFIG_BOXBLUR_OPENCL_FILTER)         += vf_avgblur_opencl.o opencl.o \
                                                opencl/avgblur.o boxblur.o
OBJS-$(CONFIG_BWDIF_FILTER)                  += vf_bwdif.o yadif_common.o
OBJS-$(CONFIG_CAS_FILTER)                    += vf_cas.o
OBJS-$(CONFIG_CHROMABER_VULKAN_FILTER)       += vf_chromaber_vulkan.o vulkan.o
OBJS-$(CONFIG_CHROMAHOLD_FILTER)             += vf_chromakey.o
OBJS-$(CONFIG_CHROMAKEY_FILTER)              += vf_chromakey.o
OBJS-$(CONFIG_CHROMANR_FILTER)               += vf_chromanr.o
OBJS-$(CONFIG_CHROMASHIFT_FILTER)            += vf_chromashift.o
OBJS-$(CONFIG_CIESCOPE_FILTER)               += vf_ciescope.o

=== src/CMakeLists.txt ===
# Translation files
set(ts_files
	gui/designer/translations/ar_AR.ts
	gui/designer/translations/de_DE.ts
	gui/designer/translations/en_EN.ts
	gui/designer/translations/es_ES.ts
	gui/designer/translations/fr_FR.ts
	gui/designer/translations/hu_HU.ts
	gui/designer/translations/it_IT.ts
	gui/designer/translations/pl_PL.ts
	gui/designer/translations/pt_BR.ts
	gui/designer/translations/ru_RU.ts
	gui/designer/translations/tr_TR.ts
	gui/designer/translations/zh_CN.ts

	gui/designer/translations/qt_ar.ts
	gui/designer/translations/qt_de.ts
	gui/designer/translations/qt_es.ts
	gui/designer/translations/qt_fr.ts
	gui/designer/translations/qt_hu.ts
	gui/designer/translations/qt_it.ts
	gui/designer/translations/qt_pl.ts
	gui/designer/translations/qt_pt_BR.ts
	gui/designer/translations/qt_ru.ts
	gui/designer/translations/qt_tr.ts
	gui/designer/translations/qt_zh_CN.ts
	)
set_source_files_properties(${ts_files} PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/translations")
configure_file(gui/designer/translations.qrc ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
qt_add_translation(qm_files ${ts_files})
add_custom_target(translations DEPENDS ${qm_files})

include(FetchContent)
if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
	set(P7ZIP_SOURCE_DIR "${CMAKE_SOURCE_DIR}/src/extra/7z1900" CACHE INTERNAL "7ZIP source dir")
else()
	set(P7ZIP_SOURCE_DIR "${CMAKE_SOURCE_DIR}/src/extra/p7zip-17.04" CACHE INTERNAL "7ZIP source dir")
endif()
FetchContent_Declare(lib7zip
	SOURCE_DIR ${CMAKE_SOURCE_DIR}/src/extra/lib7zip-53abfeb
	)
FetchContent_MakeAvailable(lib7zip)

FetchContent_Declare(qkeycode
	SOURCE_DIR ${CMAKE_SOURCE_DIR}/src/extra/qkeycode
	)
FetchContent_MakeAvailable(qkeycode)

set(audio_srcs
	audio/blip_buf.c
	audio/blipbuf.c
	audio/channels.c
	audio/delay.c
	audio/handler.c
	audio/mono.c
	audio/panning.c
	audio/wave.c
	$<$<PLATFORM_ID:Linux>:
		audio/alsa/snd.c
	>
	$<$<PLATFORM_ID:FreeBSD,OpenBSD>:
		audio/sndio/snd.c
	>
	$<$<PLATFORM_ID:Windows>:
		audio/xaudio/snd.c
	>
	)

set(c++_srcs
	c++/crc/crc.cpp
	c++/crc/Crc32.cpp
	c++/l7zip/l7z.cpp
	c++/pic16c5x/pic16c5x.cpp
	c++/pic16c5x/pic16c5x_m.cpp
	c++/xBRZ/xbrz.cpp
	c++/xBRZ/xbrz_wrap.cpp
	)

set(core_srcs
	core/input/arkanoid.c
	core/input/famicom.c
	core/input/family_basic_keyboard.c
	core/input/four_score.c
	core/input/nes_001.c
	core/input/nsf_controller.c
	core/input/nsf_mouse.c
	core/input/oeka_kids_tablet.c
	core/input/snes_mouse.c
	core/input/standard_controller.c
	core/input/subor_keyboard.c
	core/input/vs.c
	core/input/zapper.c

	core/mappers/mapper_000.c
	core/mappers/mapper_001.c
	core/mappers/mapper_002.c
	core/mappers/mapper_003.c
	core/mappers/mapper_004.c
	core/mappers/mapper_005.c
	core/mappers/mapper_006.c
	core/mappers/mapper_007.c
	core/mappers/mapper_009.c
	core/mappers/mapper_010.c
	core/mappers/mapper_011.c
	core/mappers/mapper_012.c
	core/mappers/mapper_013.c
	core/mappers/mapper_014.c
	core/mappers/mapper_015.c
	core/mappers/mapper_016.c
	core/mappers/mapper_018.c
	core/mappers/mapper_019.c
	core/mappers/mapper_021.c
	core/mappers/mapper_022.c
	core/mappers/mapper_023.c
	core/mappers/mapper_024.c
	core/mappers/mapper_025.c
	core/mappers/mapper_026.c
	core/mappers/mapper_027.c
	core/mappers/mapper_028.c
	core/mappers/mapper_029.c
	core/mappers/mapper_030.c
	core/mappers/mapper_031.c
	core/mappers/mapper_032.c
	core/mappers/mapper_033.c
	core/mappers/mapper_034.c
	core/mappers/mapper_036.c
	core/mappers/mapper_037.c
	core/mappers/mapper_038.c
	core/mappers/mapper_040.c
	core/mappers/mapper_041.c
	core/mappers/mapper_042.c
	core/mappers/mapper_043.c
	core/mappers/mapper_044.c
	core/mappers/mapper_045.c
	core/mappers/mapper_046.c
	core/mappers/mapper_047.c
	core/mappers/mapper_048.c
	core/mappers/mapper_049.c
	core/mappers/mapper_050.c
	core/mappers/mapper_051.c
	core/mappers/mapper_052.c
	core/mappers/mapper_053.c
	core/mappers/mapper_055.c
	core/mappers/mapper_056.c
	core/mappers/mapper_057.c
	core/mappers/mapper_058.c
	core/mappers/mapper_059.c
	core/mappers/mapper_060.c
	core/mappers/mapper_061.c
	core/mappers/mapper_062.c
	core/mappers/mapper_063.c
	core/mappers/mapper_064.c
	core/mappers/mapper_065.c
	core/mappers/mapper_066.c
	core/mappers/mapper_067.c
	core/mappers/mapper_068.c
	core/mappers/mapper_069.c
	core/mappers/mapper_070.c
	core/mappers/mapper_071.c
	core/mappers/mapper_072.c
	core/mappers/mapper_073.c
	core/mappers/mapper_074.c
	core/mappers/mapper_075.c
	core/mappers/mapper_076.c
	core/mappers/mapper_077.c
	core/mappers/mapper_078.c
	core/mappers/mapper_079.c
	core/mappers/mapper_080.c
	core/mappers/mapper_081.c
	core/mappers/mapper_082.c
	core/mappers/mapper_083.c
	core/mappers/mapper_085.c
	core/mappers/mapper_086.c
	core/mappers/mapper_087.c
	core/mappers/mapper_088.c
	core/mappers/mapper_089.c
	core/mappers/mapper_091.c
	core/mappers/mapper_093.c
	core/mappers/mapper_094.c
	core/mappers/mapper_095.c
	core/mappers/mapper_096.c
	core/mappers/mapper_097.c
	core/mappers/mapper_099.c
	core/mappers/mapper_100.c
	core/mappers/mapper_101.c
	core/mappers/mapper_103.c
	core/mappers/mapper_104.c
	core/mappers/mapper_105.c
	core/mappers/mapper_106.c
	core/mappers/mapper_107.c
	core/mappers/mapper_108.c
	core/mappers/mapper_111.c
	core/mappers/mapper_112.c
	core/mappers/mapper_113.c
	core/mappers/mapper_114.c
	core/mappers/mapper_115.c
	core/mappers/mapper_116.c
	core/mappers/mapper_117.c
	core/mappers/mapper_118.c
	core/mappers/mapper_119.c
	core/mappers/mapper_120.c
	core/mappers/mapper_121.c
	core/mappers/mapper_123.c
	core/mappers/mapper_125.c
	core/mappers/mapper_126.c
	core/mappers/mapper_132.c
	core/mappers/mapper_133.c
	core/mappers/mapper_134.c
	core/mappers/mapper_136.c
	core/mappers/mapper_137.c
	core/mappers/mapper_138.c
	core/mappers/mapper_139.c
	core/mappers/mapper_140.c
	core/mappers/mapper_141.c
	core/mappers/mapper_142.c
	core/mappers/mapper_143.c
	core/mappers/mapper_144.c
	core/mappers/mapper_145.c
	core/mappers/mapper_147.c
	core/mappers/mapper_148.c
	core/mappers/mapper_149.c
	core/mappers/mapper_150.c
	core/mappers/mapper_152.c
	core/mappers/mapper_153.c
	core/mappers/mapper_154.c
	core/mappers/mapper_156.c
	core/mappers/mapper_157.c
	core/mappers/mapper_159.c
	core/mappers/mapper_162.c
	core/mappers/mapper_163.c
	core/mappers/mapper_164.c
	core/mappers/mapper_165.c
	core/mappers/mapper_166.c
	core/mappers/mapper_167.c
	core/mappers/mapper_168.c
	core/mappers/mapper_170.c
	core/mappers/mapper_171.c
	core/mappers/mapper_172.c
	core/mappers/mapper_173.c
	core/mappers/mapper_175.c
	core/mappers/mapper_176.c
	core/mappers/mapper_177.c
	core/mappers/mapper_178.c
	core/mappers/mapper_180.c
	core/mappers/mapper_182.c
	core/mappers/mapper_183.c
	core/mappers/mapper_184.c
	core/mappers/mapper_185.c
	core/mappers/mapper_186.c
	core/mappers/mapper_187.c
	core/mappers/mapper_188.c
	core/mappers/mapper_189.c
	core/mappers/mapper_190.c
	core/mappers/mapper_191.c
	core/mappers/mapper_192.c
	core/mappers/mapper_193.c
	core/mappers/mapper_194.c
	core/mappers/mapper_195.c
	core/mappers/mapper_196.c
	core/mappers/mapper_197.c
	core/mappers/mapper_198.c
	core/mappers/mapper_199.c
	core/mappers/mapper_200.c
	core/mappers/mapper_201.c
	core/mappers/mapper_202.c
	core/mappers/mapper_203.c
	core/mappers/mapper_204.c
	core/mappers/mapper_205.c
	core/mappers/mapper_206.c
	core/mappers/mapper_208.c
	core/mappers/mapper_209.c
	core/mappers/mapper_210.c
	core/mappers/mapper_212.c
	core/mappers/mapper_214.c
	core/mappers/mapper_215.c
	core/mappers/mapper_216.c
	core/mappers/mapper_217.c
	core/mappers/mapper_218.c
	core/mappers/mapper_219.c
	core/mappers/mapper_221.c
	core/mappers/mapper_222.c
	core/mappers/mapper_225.c
	core/mappers/mapper_226.c
	core/mappers/mapper_227.c
	core/mappers/mapper_228.c
	core/mappers/mapper_229.c
	core/mappers/mapper_230.c
	core/mappers/mapper_231.c
	core/mappers/mapper_232.c
	core/mappers/mapper_233.c
	core/mappers/mapper_234.c
	core/mappers/mapper_235.c
	core/mappers/mapper_236.c
	core/mappers/mapper_237.c
	core/mappers/mapper_238.c
	core/mappers/mapper_240.c
	core/mappers/mapper_241.c
	core/mappers/mapper_242.c
	core/mappers/mapper_244.c
	core/mappers/mapper_245.c
	core/mappers/mapper_246.c
	core/mappers/mapper_249.c
	core/mappers/mapper_250.c
	core/mappers/mapper_252.c
	core/mappers/mapper_254.c
	core/mappers/mapper_256.c
	core/mappers/mapper_259.c
	core/mappers/mapper_260.c
	core/mappers/mapper_261.c
	core/mappers/mapper_262.c
	core/mappers/mapper_263.c
	core/mappers/mapper_265.c
	core/mappers/mapper_266.c
	core/mappers/mapper_267.c
	core/mappers/mapper_268.c
	core/mappers/mapper_269.c
	core/mappers/mapper_271.c
	core/mappers/mapper_272.c
	core/mappers/mapper_274.c
	core/mappers/mapper_281.c
	core/mappers/mapper_282.c
	core/mappers/mapper_283.c
	core/mappers/mapper_284.c
	core/mappers/mapper_285.c
	core/mappers/mapper_286.c
	core/mappers/mapper_287.c
	core/mappers/mapper_288.c
	core/mappers/mapper_289.c
	core/mappers/mapper_290.c
	core/mappers/mapper_291.c
	core/mappers/mapper_292.c
	core/mappers/mapper_295.c
	core/mappers/mapper_297.c
	core/mappers/mapper_298.c
	core/mappers/mapper_299.c
	core/mappers/mapper_300.c
	core/mappers/mapper_301.c
	core/mappers/mapper_302.c
	core/mappers/mapper_303.c
	core/mappers/mapper_304.c
	core/mappers/mapper_305.c
	core/mappers/mapper_306.c
	core/mappers/mapper_307.c
	core/mappers/mapper_308.c
	core/mappers/mapper_309.c
	core/mappers/mapper_311.c
	core/mappers/mapper_312.c
	core/mappers/mapper_313.c
	core/mappers/mapper_314.c
	core/mappers/mapper_315.c
	core/mappers/mapper_319.c
	core/mappers/mapper_320.c
	core/mappers/mapper_322.c
	core/mappers/mapper_323.c
	core/mappers/mapper_324.c
	core/mappers/mapper_325.c
	core/mappers/mapper_327.c
	core/mappers/mapper_328.c
	core/mappers/mapper_329.c
	core/mappers/mapper_331.c
	core/mappers/mapper_332.c
	core/mappers/mapper_333.c
	core/mappers/mapper_334.c
	core/mappers/mapper_335.c
	core/mappers/mapper_336.c
	core/mappers/mapper_337.c
	core/mappers/mapper_338.c
	core/mappers/mapper_339.c
	core/mappers/mapper_340.c
	core/mappers/mapper_341.c
	core/mappers/mapper_342.c
	core/mappers/mapper_343.c
	core/mappers/mapper_344.c
	core/mappers/mapper_345.c
	core/mappers/mapper_346.c
	core/mappers/mapper_347.c
	core/mappers/mapper_348.c
	core/mappers/mapper_349.c
	core/mappers/mapper_350.c
	core/mappers/mapper_351.c
	core/mappers/mapper_352.c
	core/mappers/mapper_353.c
	core/mappers/mapper_354.c
	core/mappers/mapper_355.c
	core/mappers/mapper_356.c
	core/mappers/mapper_357.c
	core/mappers/mapper_358.c
	core/mappers/mapper_359.c
	core/mappers/mapper_360.c
	core/mappers/mapper_361.c
	core/mappers/mapper_362.c
	core/mappers/mapper_366.c
	core/mappers/mapper_368.c
	core/mappers/mapper_369.c
	core/mappers/mapper_370.c
	core/mappers/mapper_372.c
	core/mappers/mapper_374.c
	core/mappers/mapper_375.c
	core/mappers/mapper_377.c
	core/mappers/mapper_380.c
	core/mappers/mapper_381.c
	core/mappers/mapper_382.c
	core/mappers/mapper_384.c
	core/mappers/mapper_386.c
	core/mappers/mapper_387.c
	core/mappers/mapper_388.c
	core/mappers/mapper_389.c
	core/mappers/mapper_390.c
	core/mappers/mapper_393.c
	core/mappers/mapper_394.c
	core/mappers/mapper_395.c
	core/mappers/mapper_396.c
	core/mappers/mapper_397.c
	core/mappers/mapper_398.c
	core/mappers/mapper_399.c
	core/mappers/mapper_400.c
	core/mappers/mapper_401.c
	core/mappers/mapper_403.c
	core/mappers/mapper_404.c
	core/mappers/mapper_406.c
	core/mappers/mapper_409.c
	core/mappers/mapper_410.c
	core/mappers/mapper_411.c
	core/mappers/mapper_412.c
	core/mappers/mapper_413.c
	core/mappers/mapper_414.c
	core/mappers/mapper_415.c
	core/mappers/mapper_416.c
	core/mappers/mapper_417.c
	core/mappers/mapper_420.c
	core/mappers/mapper_421.c
	core/mappers/mapper_428.c
	core/mappers/mapper_429.c
	core/mappers/mapper_431.c
	core/mappers/mapper_432.c
	core/mappers/mapper_433.c
	core/mappers/mapper_434.c
	core/mappers/mapper_436.c
	core/mappers/mapper_437.c
	core/mappers/mapper_438.c
	core/mappers/mapper_442.c
	core/mappers/mapper_446.c
	core/mappers/mapper_447.c
	core/mappers/mapper_451.c

=== source/common/CMakeLists.txt ===
# vim: syntax=cmake

list(APPEND VFLAGS "-DX265_VERSION=${X265_VERSION}")
if(EXTRA_LIB)
    if(LINKED_8BIT)
        list(APPEND VFLAGS "-DLINKED_8BIT=1")
    endif(LINKED_8BIT)
    if(LINKED_10BIT)
        list(APPEND VFLAGS "-DLINKED_10BIT=1")
    endif(LINKED_10BIT)
    if(LINKED_12BIT)
        list(APPEND VFLAGS "-DLINKED_12BIT=1")
    endif(LINKED_12BIT)
endif(EXTRA_LIB)

if(ENABLE_ASSEMBLY)
    set_source_files_properties(threading.cpp primitives.cpp PROPERTIES COMPILE_FLAGS -DENABLE_ASSEMBLY=1)
    list(APPEND VFLAGS "-DENABLE_ASSEMBLY=1")
endif(ENABLE_ASSEMBLY)

if(ENABLE_ASSEMBLY AND X86)
    set(SSE3  vec/dct-sse3.cpp)
    set(SSSE3 vec/dct-ssse3.cpp)
    set(SSE41 vec/dct-sse41.cpp)

    if(MSVC)
        set(PRIMITIVES ${SSE3} ${SSSE3} ${SSE41})
        set(WARNDISABLE "/wd4100") # unreferenced formal parameter
        if(INTEL_CXX)
            add_definitions(/Qwd111) # statement is unreachable
            add_definitions(/Qwd128) # loop is unreachable
            add_definitions(/Qwd177) # declared function is unused
            add_definitions(/Qwd185) # dynamic initialization in unreachable code
            add_definitions(/Qwd280) # conditional expression is constant
        endif()
        if(X64)
            set_source_files_properties(${SSE3} ${SSSE3} ${SSE41} PROPERTIES COMPILE_FLAGS "${WARNDISABLE}")
        else()
            # x64 implies SSE4, so only add /arch:SSE2 if building for Win32
            set_source_files_properties(${SSE3} ${SSSE3} ${SSE41} PROPERTIES COMPILE_FLAGS "${WARNDISABLE} /arch:SSE2")
        endif()
    endif()
    if(GCC)
        if(CLANG)
            # llvm intrinsic headers cause shadow warnings
            set(WARNDISABLE "-Wno-shadow -Wno-unused-parameter")
        else()
            set(WARNDISABLE "-Wno-unused-parameter")
        endif()
        if(INTEL_CXX OR CLANG OR (NOT CC_VERSION VERSION_LESS 4.3))
            set(PRIMITIVES ${SSE3} ${SSSE3} ${SSE41})
            set_source_files_properties(${SSE3}  PROPERTIES COMPILE_FLAGS "${WARNDISABLE} -msse3")
            set_source_files_properties(${SSSE3} PROPERTIES COMPILE_FLAGS "${WARNDISABLE} -mssse3")
            set_source_files_properties(${SSE41} PROPERTIES COMPILE_FLAGS "${WARNDISABLE} -msse4.1")
        endif()
    endif()
    set(VEC_PRIMITIVES vec/vec-primitives.cpp ${PRIMITIVES})
    source_group(Intrinsics FILES ${VEC_PRIMITIVES})
    set(C_SRCS asm-primitives.cpp pixel.h mc.h ipfilter8.h blockcopy8.h dct8.h loopfilter.h seaintegral.h)
    set(A_SRCS pixel-a.asm const-a.asm cpu-a.asm ssd-a.asm mc-a.asm
               mc-a2.asm pixel-util8.asm blockcopy8.asm
               pixeladd8.asm dct8.asm seaintegral.asm)
    if(HIGH_BIT_DEPTH)
        set(A_SRCS ${A_SRCS} sad16-a.asm intrapred16.asm v4-ipfilter16.asm h4-ipfilter16.asm h-ipfilter16.asm ipfilter16.asm loopfilter.asm)
    else()
        set(A_SRCS ${A_SRCS} sad-a.asm intrapred8.asm intrapred8_allangs.asm v4-ipfilter8.asm h-ipfilter8.asm ipfilter8.asm loopfilter.asm)
    endif()
    if(NOT X64)
        set(A_SRCS ${A_SRCS} pixel-32.asm)
    endif()

    if(MSVC_IDE OR XCODE)
        # MSVC requires custom build rules in the main cmake script for nasm
        set(MSVC_ASMS "${A_SRCS}" CACHE INTERNAL "nasm sources")
        set(A_SRCS)
    endif()

    enable_language(ASM_NASM)

    foreach(SRC ${A_SRCS} ${C_SRCS})
        set(ASM_PRIMITIVES ${ASM_PRIMITIVES} x86/${SRC})
    endforeach()
    source_group(Assembly FILES ${ASM_PRIMITIVES})
endif(ENABLE_ASSEMBLY AND X86)

if(ENABLE_ASSEMBLY AND (ARM OR CROSS_COMPILE_ARM))
    set(C_SRCS asm-primitives.cpp pixel.h mc.h ipfilter8.h blockcopy8.h dct8.h loopfilter.h)

    # add ARM assembly/intrinsic files here
    set(A_SRCS asm.S cpu-a.S mc-a.S sad-a.S pixel-util.S ssd-a.S blockcopy8.S ipfilter8.S dct-a.S)
    set(VEC_PRIMITIVES)

    set(ARM_ASMS "${A_SRCS}" CACHE INTERNAL "ARM Assembly Sources")
    foreach(SRC ${C_SRCS})
        set(ASM_PRIMITIVES ${ASM_PRIMITIVES} arm/${SRC})
    endforeach()
    source_group(Assembly FILES ${ASM_PRIMITIVES})
endif(ENABLE_ASSEMBLY AND (ARM OR CROSS_COMPILE_ARM))

if(POWER)
    set_source_files_properties(version.cpp PROPERTIES COMPILE_FLAGS -DX265_VERSION=${X265_VERSION})
    if(ENABLE_ALTIVEC)
        set(ALTIVEC_SRCS pixel_altivec.cpp dct_altivec.cpp ipfilter_altivec.cpp intrapred_altivec.cpp)
        foreach(SRC ${ALTIVEC_SRCS})
            set(ALTIVEC_PRIMITIVES ${ALTIVEC_PRIMITIVES} ppc/${SRC})
        endforeach()
        source_group(Intrinsics_altivec FILES ${ALTIVEC_PRIMITIVES})
        set_source_files_properties(${ALTIVEC_PRIMITIVES} PROPERTIES COMPILE_FLAGS "-Wno-unused  -Wno-unknown-pragmas -Wno-maybe-uninitialized")
    endif()
endif()


# set_target_properties can't do list expansion
string(REPLACE ";" " " VERSION_FLAGS "${VFLAGS}")
set_source_files_properties(version.cpp PROPERTIES COMPILE_FLAGS ${VERSION_FLAGS})

check_symbol_exists(strtok_r "string.h" HAVE_STRTOK_R)
if(HAVE_STRTOK_R)
    set_source_files_properties(param.cpp PROPERTIES COMPILE_FLAGS -DHAVE_STRTOK_R=1)
endif()

if(GCC AND CC_HAS_NO_NARROWING)
    set_source_files_properties(cpu.cpp PROPERTIES COMPILE_FLAGS -Wno-narrowing)
endif()
if(WIN32)
    set(WINXP winxp.h winxp.cpp)
endif(WIN32)

add_library(common OBJECT
    ${ASM_PRIMITIVES} ${VEC_PRIMITIVES} ${ALTIVEC_PRIMITIVES} ${WINXP}
    primitives.cpp primitives.h
    pixel.cpp dct.cpp lowpassdct.cpp ipfilter.cpp intrapred.cpp loopfilter.cpp
    constants.cpp constants.h
    cpu.cpp cpu.h version.cpp
    threading.cpp threading.h
    threadpool.cpp threadpool.h
    wavefront.h wavefront.cpp
    md5.cpp md5.h
    bitstream.h bitstream.cpp
    yuv.cpp yuv.h
    shortyuv.cpp shortyuv.h
    picyuv.cpp picyuv.h
    common.cpp common.h
    param.cpp param.h
    frame.cpp frame.h
    framedata.cpp framedata.h
    cudata.cpp cudata.h
    slice.cpp slice.h
    lowres.cpp lowres.h mv.h 
    piclist.cpp piclist.h
    predict.cpp  predict.h
    scalinglist.cpp scalinglist.h
    quant.cpp quant.h contexts.h
    deblock.cpp deblock.h)

=== source/test/CMakeLists.txt ===
# vim: syntax=cmake

check_symbol_exists(__rdtsc "intrin.h" HAVE_RDTSC)
if(HAVE_RDTSC)
    add_definitions(-DHAVE_RDTSC=1)
endif()

# add X86 assembly files
if(X86)
enable_language(ASM_NASM)

if(MSVC_IDE)
    set(NASM_SRC checkasm-a.obj)
    add_custom_command(
        OUTPUT checkasm-a.obj
        COMMAND ${NASM_EXECUTABLE}
        ARGS ${NASM_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/checkasm-a.asm -o checkasm-a.obj
        DEPENDS checkasm-a.asm)
else()
    set(NASM_SRC checkasm-a.asm)
endif()
endif(X86)

# add ARM assembly files
if(ARM OR CROSS_COMPILE_ARM)
    enable_language(ASM)
    set(NASM_SRC checkasm-arm.S)
    add_custom_command(
        OUTPUT checkasm-arm.obj
        COMMAND ${CMAKE_CXX_COMPILER}
        ARGS ${NASM_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/checkasm-arm.S -o checkasm-arm.obj
        DEPENDS checkasm-arm.S)
endif(ARM OR CROSS_COMPILE_ARM)

# add PowerPC assembly files
if(POWER)
    set(NASM_SRC)
endif(POWER)

add_executable(TestBench ${NASM_SRC}
    testbench.cpp testharness.h
    pixelharness.cpp pixelharness.h
    mbdstharness.cpp mbdstharness.h
    ipfilterharness.cpp ipfilterharness.h
    intrapredharness.cpp intrapredharness.h)

target_link_libraries(TestBench x265-static ${PLATFORM_LIBS})
if(LINKER_OPTIONS)
    if(EXTRA_LIB)
        list(APPEND LINKER_OPTIONS "-L..")
    endif(EXTRA_LIB)
    string(REPLACE ";" " " LINKER_OPTION_STR "${LINKER_OPTIONS}")
    set_target_properties(TestBench PROPERTIES LINK_FLAGS "${LINKER_OPTION_STR}")
endif()

=== src/extra/NTSC-CRT/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14...3.25)

get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(NOT is_multi_config AND NOT (CMAKE_BUILD_TYPE OR DEFINED ENV{CMAKE_BUILD_TYPE}))
	set(CMAKE_BUILD_TYPE Release CACHE STRING "Release default")
endif()

project(NTSC-CRT LANGUAGES C)

option(LIVE "Live video using PL3D-KC" OFF)
option(VIDEO "Convert video (series of frames) instead of single image" OFF)
set(CRT_SYSTEM "0" CACHE STRING "The system to be compiled (0 - CRT_SYSTEM_NTSC - standard NTSC, 5 - CRT_SYSTEM_NTSCVHS - standard NTSC VHS)")

include(ExternalProject)
include(GNUInstallDirs)

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
	set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}" CACHE PATH "default install path" FORCE)
endif()

# --- PL3D-KC
if(LIVE)
	if(UNIX)
		find_package(X11 REQUIRED)
	endif()

	set(fw_url https://github.com/LMP88959/PL3D-KC.git)
	set(fw_tag 3fa35ad)
	set(fw_args
	-DCMAKE_INSTALL_PREFIX:PATH=${CMAKE_INSTALL_PREFIX}
	-DCMAKE_BUILD_TYPE=Release
	-DBUILD_SHARED_LIBS:BOOL=${BUILD_SHARED_LIBS}
	-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}
	)

	set(FW_LIBRARY ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}fw${CMAKE_STATIC_LIBRARY_SUFFIX})
	set(FW_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR})


	ExternalProject_Add(fw
	GIT_REPOSITORY ${fw_url}
	GIT_TAG ${fw_tag}
	GIT_SHALLOW true
	CMAKE_ARGS ${fw_args}
	BUILD_BYPRODUCTS ${FW_LIBRARY}
	TLS_VERIFY true
	INACTIVITY_TIMEOUT 60
	CONFIGURE_HANDLED_BY_BUILD ON
	)

	file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include)
	add_library(fw::fw INTERFACE IMPORTED)
	target_link_libraries(fw::fw INTERFACE ${FW_LIBRARY}
	$<$<BOOL:${UNIX}>:X11::Xext>
	$<$<BOOL:${WIN32}>:winmm>
	)
	target_include_directories(fw::fw INTERFACE ${FW_INCLUDE_DIR})

	add_dependencies(fw::fw fw)
endif()

# --- NTSC program
# --- Check CRT_SYSTEM value
if((CRT_SYSTEM LESS 0) OR (CRT_SYSTEM GREATER 5))
	message(FATAL_ERROR "Wrong CRT_SYSTEM value! Possible values: 0 - 5")
endif()

# --- video_convert
if(VIDEO)
	add_executable(ntsc_video video_convert.c crt_core.c crt_ntsc.c crt_ntscvhs.c crt_pv1k.c crt_template.c bmp_rw.c)
	target_include_directories(ntsc_video PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
	target_compile_definitions(ntsc_video PRIVATE CRT_SYSTEM=${CRT_SYSTEM})
	target_compile_definitions(ntsc_video PRIVATE
	CMD_LINE_VERSION=$<NOT:$<BOOL:${LIVE}>>
	$<$<BOOL:${MSVC}>:_CRT_SECURE_NO_WARNINGS>
	)
	target_link_libraries(ntsc_video PRIVATE
	$<$<BOOL:${LIVE}>:fw::fw>
	$<$<BOOL:${WIN32}>:winmm>
	)
	
# --- default
else()
	add_executable(ntsc crt_core.c crt_ntsc.c crt_nes.c crt_pv1k.c crt_template.c crt_snes.c crt_main.c ppm_rw.c bmp_rw.c)
	target_include_directories(ntsc PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
	target_compile_definitions(ntsc PRIVATE CRT_SYSTEM=${CRT_SYSTEM})
	target_compile_definitions(ntsc PRIVATE
	CMD_LINE_VERSION=$<NOT:$<BOOL:${LIVE}>>
	$<$<BOOL:${MSVC}>:_CRT_SECURE_NO_WARNINGS>
	)
	target_link_libraries(ntsc PRIVATE
	$<$<BOOL:${LIVE}>:fw::fw>
	$<$<BOOL:${WIN32}>:winmm>
	)
endif()

# --- auto-ignore build directory
if(NOT EXISTS ${PROJECT_BINARY_DIR}/.gitignore)
	file(WRITE ${PROJECT_BINARY_DIR}/.gitignore "*")
endif()

=== src/extra/PAL-CRT/CMakeLists.txt ===
# kindly provided by scivision

cmake_minimum_required(VERSION 3.14...3.25)

get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(NOT is_multi_config AND NOT (CMAKE_BUILD_TYPE OR DEFINED ENV{CMAKE_BUILD_TYPE}))
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Release default")
endif()

project(PAL-CRT LANGUAGES C)

option(live "live video using PL3D-KC")

include(ExternalProject)
include(GNUInstallDirs)

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}" CACHE PATH "default install path" FORCE)
endif()

# --- PL3D-KC
if(live)
if(UNIX)
  find_package(X11 REQUIRED)
endif()

set(fw_url https://github.com/LMP88959/PL3D-KC.git)
set(fw_tag 3fa35ad)
set(fw_args
-DCMAKE_INSTALL_PREFIX:PATH=${CMAKE_INSTALL_PREFIX}
-DCMAKE_BUILD_TYPE=Release
-DBUILD_SHARED_LIBS:BOOL=${BUILD_SHARED_LIBS}
-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}
)

set(FW_LIBRARY ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}fw${CMAKE_STATIC_LIBRARY_SUFFIX})
set(FW_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR})


ExternalProject_Add(fw
GIT_REPOSITORY ${fw_url}
GIT_TAG ${fw_tag}
GIT_SHALLOW true
CMAKE_ARGS ${fw_args}
BUILD_BYPRODUCTS ${FW_LIBRARY}
TLS_VERIFY true
INACTIVITY_TIMEOUT 60
CONFIGURE_HANDLED_BY_BUILD ON
)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include)
add_library(fw::fw INTERFACE IMPORTED)
target_link_libraries(fw::fw INTERFACE ${FW_LIBRARY}
$<$<BOOL:${UNIX}>:X11::Xext>
$<$<BOOL:${WIN32}>:winmm>
)
target_include_directories(fw::fw INTERFACE ${FW_INCLUDE_DIR})

add_dependencies(fw::fw fw)
endif()

# --- PAL program
add_executable(pal pal_core.c pal.c pal_nes.c pal_main.c ppm_rw.c bmp_rw.c)
target_include_directories(pal PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_compile_definitions(pal PRIVATE
CMD_LINE_VERSION=$<NOT:$<BOOL:${live}>>
$<$<BOOL:${MSVC}>:_CRT_SECURE_NO_WARNINGS>
)
target_link_libraries(pal PRIVATE
$<$<BOOL:${live}>:fw::fw>
$<$<BOOL:${WIN32}>:winmm>
)

# --- auto-ignore build directory
if(NOT EXISTS ${PROJECT_BINARY_DIR}/.gitignore)
  file(WRITE ${PROJECT_BINARY_DIR}/.gitignore "*")
endif()

=== src/extra/filter-c/Makefile ===
CFLAGS = -Wall -Wshadow -O3 -g -march=native
LDLIBS = -lm

example: example.o filter.o

clean:
	$(RM) *.o
	$(RM) example filter *.exe

=== src/extra/lib7zip-53abfeb/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

CMAKE_POLICY(
    SET CMP0048 NEW
)

PROJECT (lib7zip
	VERSION 3.0.0
)

INCLUDE(ExternalProject)

IF(APPLE)
  SET(CMAKE_MACOSX_RPATH 1)
  SET(CMAKE_PREFIX_PATH /usr/local)
ENDIF()

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE "DEBUG")
  #SET(CMAKE_BUILD_TYPE "RELEASE")
  #SET(CMAKE_BUILD_TYPE "RELWITHDEBINFO")
  #SET(CMAKE_BUILD_TYPE "MINSIZEREL")
ENDIF()

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

OPTION(BUILD_SHARED_LIB "build shared library" OFF)
SET(P7ZIP_SOURCE_DIR "" CACHE PATH "pzip/7zip source code path")

IF (NOT IS_DIRECTORY ${P7ZIP_SOURCE_DIR})
  MESSAGE(FATAL_ERROR "must proivde p7zip/7zip source path using -DP7ZIP_SOURCE_DIR")
ENDIF()

SET(P7ZIP_INCLUDE_PATH   "${P7ZIP_SOURCE_DIR}"
  "${P7ZIP_SOURCE_DIR}/CPP"
  "${P7ZIP_SOURCE_DIR}/CPP/myWindows"
  "${P7ZIP_SOURCE_DIR}/CPP/include_windows"
)


if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  #set(warnings -Wall -Wextra -Werror -Wno-unused-parameter)
  #set(cxx_warnings -Wno-class-memaccess)
  set(warnings "")
  set(cxx_warnings "")
  set(no_undefined -Wl,--no-undefined)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  #set(warnings -Wall -Wextra -Werror -Wno-inconsistent-missing-override -Wno-unused-parameter)
  set(warnings "")
  set(cxx_warnings "")
  set(no_undefined -Wl,-undefined,error)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    set(warnings /W4 /WX /EHsc)
    set(no_undefined "")
    set(cxx_warnings "")
endif()

SET(CXX_STANDARD_REQUIRED OFF)
SET(CXX_EXTENSION NO)

if (NOT CONFIGURED_ONCE)
if ("${CMAKE_C_PLATFORM_ID}" STREQUAL "MinGW")
  ADD_COMPILE_OPTIONS(-DUNICODE -D_UNICODE -DWIN32)
endif()
ADD_COMPILE_OPTIONS(-fPIC -std=c++14 ${warnings} ${cxx_warnings})
ADD_LINK_OPTIONS(${no_undefined})
endif()

ADD_SUBDIRECTORY(src)
#ADD_SUBDIRECTORY(test)

install(FILES dummy DESTINATION bin OPTIONAL)

=== src/extra/qkeycode/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(qkeycode LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# The includer is responsible for supplying a Qt target.

add_library(qkeycode STATIC
    src/qkeycode/qkeycode.cpp
    src/qkeycode/chromium/keycode_converter.cc
)
target_include_directories(qkeycode
    PUBLIC include
    PRIVATE src
)
if(${QT_VERSION} VERSION_LESS "5.15.0")
	target_link_libraries(qkeycode PRIVATE Qt5::Gui)
else()
	target_link_libraries(qkeycode PRIVATE Qt::Gui)
endif()

target_compile_definitions(qkeycode PRIVATE KEYCODEQT_LIBRARY)

=== src/extra/lib7zip-53abfeb/src/CMakeLists.txt ===
SET(lib7zip_src
7ZipArchive.cpp             7ZipCompressCodecsInfo.cpp  7ZipFunctions.h             OSFunctions_UnixLike.cpp
7ZipArchiveItem.cpp         7ZipCompressCodecsInfo.h    7ZipInStreamWrapper.cpp     HelperFuncs.cpp             OSFunctions_UnixLike.h
7ZipArchiveOpenCallback.cpp 7ZipDllHandler.cpp          7ZipInStreamWrapper.h       HelperFuncs.h               OSFunctions_Win32.cpp
7ZipArchiveOpenCallback.h   7ZipDllHandler.h            7ZipObjectPtrArray.cpp      OSFunctions.h               OSFunctions_Win32.h
7ZipCodecInfo.cpp           7ZipFormatInfo.cpp          7ZipOpenArchive.cpp         OSFunctions_OS2.cpp         lib7zip.h
7ZipCodecInfo.h             7ZipFormatInfo.h            7zipLibrary.cpp             OSFunctions_OS2.h
)

if ("${CMAKE_C_PLATFORM_ID}" STREQUAL "MinGW")
    SET(lib7zip_src ${lib7zip_src} GUIDs.h GUIDs.cpp)
endif()

SET(lib7zip_NODIST_SOURCES ${P7ZIP_SOURCE_DIR}/CPP/Common/MyWindows.cpp
			   ${P7ZIP_SOURCE_DIR}/CPP/Windows/PropVariant.cpp
)

ADD_LIBRARY(lib7zip STATIC ${lib7zip_src}
   ${lib7zip_NODIST_SOURCES}
   )

SET_TARGET_PROPERTIES(lib7zip PROPERTIES
    OUTPUT_NAME "7zip"
)

SET_TARGET_PROPERTIES(lib7zip PROPERTIES LINKER_LANGUAGE CXX)

TARGET_INCLUDE_DIRECTORIES(lib7zip PRIVATE
  "${P7ZIP_INCLUDE_PATH}"
)
TARGET_LINK_LIBRARIES(lib7zip ${CMAKE_DL_LIBS})

IF (BUILD_SHARED_LIB)
ADD_LIBRARY(lib7zip_shared SHARED ${lib7zip_src}
   ${lib7zip_NODIST_SOURCES}
)
SET_TARGET_PROPERTIES(lib7zip_shared PROPERTIES
    OUTPUT_NAME "7zip"
)

SET_TARGET_PROPERTIES(lib7zip_shared PROPERTIES LINKER_LANGUAGE CXX)

TARGET_INCLUDE_DIRECTORIES(lib7zip_shared PRIVATE
  "${P7ZIP_INCLUDE_PATH}"
)
TARGET_LINK_LIBRARIES(lib7zip_shared ${CMAKE_DL_LIBS})

ENDIF()

=== src/extra/lib7zip-53abfeb/test/CMakeLists.txt ===
SET(common_src
    stdafx.cpp stdafx.h
)

SET (test_src Test7Zip.cpp              Test7ZipCryptFileName.cpp Test7ZipMulti.cpp         Test7ZipSignature.cpp
Test7Zip2.cpp             Test7ZipDmg.cpp           Test7ZipRar5.cpp test_archive.cpp
)

FOREACH(f ${test_src})

GET_FILENAME_COMPONENT(test_target_name ${f} NAME_WE)

MESSAGE("generate target ${test_target_name} for ${f}")

ADD_EXECUTABLE(${test_target_name}
    ${common_src}
    ${f}
)

TARGET_INCLUDE_DIRECTORIES(${test_target_name} PRIVATE
     "../src"
)

TARGET_LINK_LIBRARIES(${test_target_name}
  lib7zip
  ${CMAKE_DL_LIBS}
)

ENDFOREACH()

=== hip/debian/changelog ===
libmp3hip (0.2) unstable; urgency=low

  * Fixed problem in python wrapper with fd's not getting fclose()d on
    deletion of python objects (closes #154885).
  * Renamed python-hip to python2.1-hip and created python2.2-hip and
    python2.3-hip (closes #161579).

 -- Myers W. Carpenter <myers@fil.org>  Fri, 27 Sep 2002 02:06:09 -0400

libmp3hip (0.1.1) unstable; urgency=low

  * Non-Maintainer Upload
  * Switched to python2.2 (Closes: #161579) 

 -- Michael Banck <mbanck@debian.org>  Sat, 12 Oct 2002 20:59:57 +0200

libmp3hip (0.1) unstable; urgency=low

  * Initial Release.
  * Uploaded by sponsor.

 -- JP Sugarbroad <taral@taral.net>  Tue, 23 Apr 2002 16:46:53 -0500

Local variables:
mode: debian-changelog
End:

=== hip/debian/control ===
Source: libmp3hip
Section: libs
Priority: optional
Maintainer: Myers W. Carpenter <myers@monoloco.net>
Build-Depends: debhelper (>> 3.0.0), autotools-dev, devscripts, python2.2-dev
Standards-Version: 3.5.6.0

Package: libmp3hip0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}
Description: HIP Isn't a Player mpeg audio decoder.
 HIP Isn't a Player is a full mpeg audio decoder (MPEG 1/2/2.5, Layer I, II,
 III)
 .
 Distributed under the terms of the GNU Library General Public License
 (LGPL).

Package: libmp3hip-dev
Architecture: any
Section: devel
Depends: libmp3hip0 (= ${Source-Version}), libc6-dev
Description: HIP Isn't a Player development library
 The libmp3hip-dev package contains the header files and documentation
 needed to develop applications with libmp3hip.

Package: python-hip
Architecture: any
Depends: python (>= 2.2), python (<< 2.3), ${shlibs:Depends}
Description: A Python interface to the libmp3hip library
 This module makes the libmp3hip (MPEG 1/2/2.5, Layer I, II,
 III decoder) functions available in Python. With this module 
 you can write Python applications that can decode mpeg audio files.

Package: python2.1-hip
Architecture: any
Depends: python (>= 2.1), python (<< 2.2), ${shlibs:Depends}
Description: A Python interface to the libmp3hip library
 This module makes the libmp3hip (MPEG 1/2/2.5, Layer I, II,
 III decoder) functions available in Python. With this module 
 you can write Python applications that can decode mpeg audio files.

Package: python2.2-hip
Architecture: any
Depends: python (>= 2.2), python (<< 2.3), ${shlibs:Depends}
Description: A Python interface to the libmp3hip library
 This module makes the libmp3hip (MPEG 1/2/2.5, Layer I, II,
 III decoder) functions available in Python. With this module 
 you can write Python applications that can decode mpeg audio files.

Package: python2.3-hip
Architecture: any
Depends: python (>= 2.3), ${shlibs:Depends}
Description: A Python interface to the libmp3hip library
 This module makes the libmp3hip (MPEG 1/2/2.5, Layer I, II,
 III decoder) functions available in Python. With this module 
 you can write Python applications that can decode mpeg audio files.

=== hip/debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=3

PYTHON2.1 = /usr/bin/python2.1
PYTHON2.2 = /usr/bin/python2.2
PYTHON2.3 = /usr/bin/python2.3

export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

configure: configure-stamp
configure-stamp:
	dh_testdir

	# If compiling cvs version change to ./autogen.sh --prefix=/usr
	./configure --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE) \
	--prefix=/usr

	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	
	$(MAKE)

	cd python
	$(PYTHON2.1) setup.py build
	$(PYTHON2.2) setup.py build
	$(PYTHON2.3) setup.py build
	cd ..                        

	touch build-stamp

autotools:
	OLDDATESUB=`./config.sub -t | tr -d -` ;\
	OLDDATEGUESS=`./config.guess -t | tr -d -` ;\
	NEWDATESUB=`/usr/share/misc/config.sub -t | tr -d -` ;\
	NEWDATEGUESS=`/usr/share/misc/config.guess -t | tr -d -` ;\
	if [ $$OLDDATESUB -lt $$NEWDATESUB -o \
	     $$OLDDATEGUESS -lt $$NEWDATEGUESS ]; then \
	   dch -a -p "GNU config automated update: config.sub\
	     ($$OLDDATESUB to $$NEWDATESUB), config.guess\
	     ($$OLDDATEGUESS to $$NEWDATEGUESS)" ;\
	   cp -f /usr/share/misc/config.sub config.sub ;\
	   cp -f /usr/share/misc/config.guess config.guess ;\
	   echo WARNING: GNU config scripts updated from master copies 1>&2 ;\
	fi

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	-$(MAKE) distclean
	rm -rf python/build
	
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) install DESTDIR=`pwd`/debian/tmp


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_movefiles

	dh_installdocs
	dh_installexamples
	dh_installmanpages
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs -V
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: autotools build clean binary-indep binary-arch binary install configure
